#!/usr/bin/env ruby
# coding: utf-8

# WTFPL
# Si rompe con più di $lines canzoni, ma tanto 'sa radio non la usa nessuno


require 'curses'
require 'ruby-mpd'
require 'base64'

include Curses


mpd = MPD.new 'localhost', 6600
mpd.connect

init_screen
noecho
curs_set 0

selected = 0

loop do
  crmode
  line = 0
  mpd.queue.each do |song|
    setpos(line, 0)
    if line == selected
      addstr('> ')
    else
      addstr('  ')
    end
    addstr(Base64.urlsafe_decode64(song.file.split('#').last))
    line += 1
  end
  setpos(selected, 0)
  refresh
  key = getch
  case key
  when "q"
    break
  when "w"
    if selected == 0
      selected = mpd.queue.count-1
    else
      selected -= 1
    end
  when "s"
    if selected == (mpd.queue.count-1)
      selected = 0
    else
      selected += 1
    end
  when "d"
    mpd.delete(selected)
    clear
  when "p"
    mpd.play(selected)
  end
end

mpd.disconnect
close_screen
